//+------------------------------------------------------------------+
//|                                                     DeMarker.mq5 |
//|                   Copyright 2009-2017, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009-2017, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#include <MovingAverages.mqh>
//--- indicator settings
#property indicator_separate_window
#property indicator_buffers 10
#property indicator_plots   6
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  DodgerBlue,Red
#property indicator_level1  0.3
#property indicator_level2  0.7
#property indicator_label3  "BuyArrow"
#property indicator_type3   DRAW_ARROW
#property indicator_color3  clrAqua
#property indicator_width3  1
#property indicator_label4  "SellArrow"
#property indicator_type4   DRAW_ARROW
#property indicator_color4  clrYellow
#property indicator_width4  1
#property indicator_label5  "rightarrow"
#property indicator_type5   DRAW_ARROW
#property indicator_color5  clrLime
#property indicator_width5  1
#property indicator_label6  "wrongarrow"
#property indicator_type6   DRAW_ARROW
#property indicator_color6  clrTomato
#property indicator_width6  1
//--- input parameters
input int InpDeMarkerPeriod=14; // Period
//--- indicator buffers
double    ExtDeMarkerBuffer[];
double    ExtDeMaxBuffer[];
double    ExtDeMinBuffer[];
double    ExtAvgDeMaxBuffer[];
double    ExtAvgDeMinBuffer[];
double    ExtColor[];
double    Buy[],Sell[],right[],wrong[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,ExtDeMarkerBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,ExtColor,INDICATOR_COLOR_INDEX);
   SetIndexBuffer(2,Buy,INDICATOR_DATA);
   //ArraySetAsSeries(Buy,true);
   PlotIndexSetString(2,PLOT_LABEL,"BuyArrow");      
   PlotIndexSetInteger(2,PLOT_ARROW,242);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0);
   
   SetIndexBuffer(3,Sell,INDICATOR_DATA);
   //ArraySetAsSeries(Sell,true);
   PlotIndexSetString(3,PLOT_LABEL,"SellArrow");   
   PlotIndexSetInteger(3,PLOT_ARROW,241);
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,0);
   
   SetIndexBuffer(4,right,INDICATOR_DATA);
   //ArraySetAsSeries(right,true);
   PlotIndexSetString(4,PLOT_LABEL,"right");   
   PlotIndexSetInteger(4,PLOT_ARROW,252);
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,0);
   //PlotIndexGetInteger(4,PLOT_ARROW_SHIFT,-1);
   
   SetIndexBuffer(5,wrong,INDICATOR_DATA);
   //ArraySetAsSeries(wrong,true);
   PlotIndexSetString(5,PLOT_LABEL,"wrong");   
   PlotIndexSetInteger(5,PLOT_ARROW,251);
   PlotIndexSetDouble(5,PLOT_EMPTY_VALUE,0);  
   //PlotIndexGetInteger(5,PLOT_ARROW_SHIFT,-1);
   //ArraySetAsSeries(Sell,true);
   SetIndexBuffer(6,ExtDeMaxBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(7,ExtDeMinBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(8,ExtAvgDeMaxBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(9,ExtAvgDeMinBuffer,INDICATOR_CALCULATIONS);
//--- set accuracy
   IndicatorSetInteger(INDICATOR_DIGITS,3);
//--- sets first bar from what index will be drawn
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,InpDeMarkerPeriod);
//--- name for DataWindow and indicator subwindow label
   IndicatorSetString(INDICATOR_SHORTNAME,"DeM("+string(InpDeMarkerPeriod)+")");
//--- initialization done
  }
//+------------------------------------------------------------------+
//| DeMarker                                                         |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int    i,limit;
   double dNum;
//--- check for bars count
   if(rates_total<InpDeMarkerPeriod)
      return(0);
//--- preliminary calculations
   if(prev_calculated==0)
     {
      ExtDeMaxBuffer[0]=0.0;
      ExtDeMinBuffer[0]=0.0;
      //--- filling out the array of True Range values for each period
      for(i=1;i<InpDeMarkerPeriod;i++)
        {
         if(high[i]>high[i-1]) ExtDeMaxBuffer[i]=high[i]-high[i-1];
         else ExtDeMaxBuffer[i]=0.0;

         if(low[i-1]>low[i]) ExtDeMinBuffer[i]=low[i-1]-low[i];
         else ExtDeMinBuffer[i]=0.0;
        }
      for(i=0;i<InpDeMarkerPeriod;i++) ExtDeMarkerBuffer[i]=0.0;
      limit=InpDeMarkerPeriod-1;
    }
   else limit=prev_calculated-1;
//--- the main loop of calculations
   for(i=limit;i<rates_total && !IsStopped();i++)
     {
      if(high[i]>high[i-1]) ExtDeMaxBuffer[i]=high[i]-high[i-1];
      else ExtDeMaxBuffer[i]=0.0;

      if(low[i-1]>low[i]) ExtDeMinBuffer[i]=low[i-1]-low[i];
      else ExtDeMinBuffer[i]=0.0;

      ExtAvgDeMaxBuffer[i]=SimpleMA(i,InpDeMarkerPeriod,ExtDeMaxBuffer);
      ExtAvgDeMinBuffer[i]=SimpleMA(i,InpDeMarkerPeriod,ExtDeMinBuffer);

      dNum=ExtAvgDeMaxBuffer[i]+ExtAvgDeMinBuffer[i];
      if(dNum!=0) ExtDeMarkerBuffer[i]=ExtAvgDeMaxBuffer[i]/dNum;
      else ExtDeMarkerBuffer[i]=0.0;
     }
     if(ExtDeMarkerBuffer[rates_total-2] - ExtDeMarkerBuffer[rates_total-1] > 0)
     {
     Buy[rates_total - 1 ] = 1;
     //Sell[rates_total-1] = 0;
     right[rates_total-1] = 0.7;
     Print("Buy");
     }
     if(ExtDeMarkerBuffer[rates_total-2] - ExtDeMarkerBuffer[rates_total-1] < 0)
     {
     //Buy[rates_total - 1 ] = 0;
     wrong[rates_total-1] = 0.7;
     Sell[rates_total-1] = 1;
     Print("Sell");
     }
//--- OnCalculate done. Return new prev_calculated.
   return(rates_total);
  }
//+------------------------------------------------------------------+
